Option Explicit
'
'     
Global Const MSCOMM_EV_SEND = 1
Global Const MSCOMM_EV_RECEIVE = 2
Global Const MSCOMM_EV_CTS = 3
Global Const MSCOMM_EV_DSR = 4
Global Const MSCOMM_EV_CD = 5
Global Const MSCOMM_EV_RING = 6
Global Const MSCOMM_EV_EOF = 7
'
Global Const MSCOMM_ER_BREAK = 1001
Global Const MSCOMM_ER_CTSTO = 1002
Global Const MSCOMM_ER_DSRTO = 1003
Global Const MSCOMM_ER_FRAME = 1004
Global Const MSCOMM_ER_OVERRUN = 1006
Global Const MSCOMM_ER_CDTO = 1007
Global Const MSCOMM_ER_RXOVER = 1008
Global Const MSCOMM_ER_RXPARITY = 1009
Global Const MSCOMM_ER_TXFULL = 1010
'
Global Const CDERR_CANCEL = 32755
Global Const CF_SCREENFONTS = &H1&

Function ComPortWait (comC As MSComm, iSetWait As Integer) As Integer
  '
  '    .
  Dim iB As Integer
  Dim iE As Integer
  '
  Dim iI As Integer
  '
  ComPortWait = True
  '
  iB = 0
  iI = 0
  While iB = 0
    iB = comC.InBufferCount
    iI = iI + 1
    If iI > iSetWait Then
      ComPortWait = False
      Exit Function
    End If
  Wend
  '
  For iI = 1 To iSetWait
    iE = comC.InBufferCount
  Next iI
  '
  While (iE - iB) <> 0
    iB = iE
    For iI = 1 To iSetWait
      iE = comC.InBufferCount
    Next iI
  Wend
End Function

Sub GetCom (comC As MSComm, sComSet As String)
  On Error Resume Next
  '
  Dim sBPDS As String
  Dim iPort As Integer
  Dim iHShake As Integer
  '
  sBPDS = comC.Settings
  iPort = comC.CommPort
  iHShake = comC.Handshaking
  sComSet = ""
  sComSet = sComSet + sBPDS
  sComSet = sComSet + ","
  sComSet = sComSet + Trim$(Str$(iPort))
  sComSet = sComSet + ","
  sComSet = sComSet + Trim$(Str$(iHShake))
End Sub

Sub OnCom (comC As MSComm, lblM As Label)
  Dim sEVMsg As String
  Dim sERMsg As String
  Dim iR As Integer
  '
  Select Case comC.CommEvent
  '   
  Case MSCOMM_EV_RECEIVE
    sEVMsg = " "
  Case MSCOMM_EV_SEND
    sEVMsg = " "
  Case MSCOMM_EV_CTS
    sEVMsg = "   CTS"
  Case MSCOMM_EV_DSR
    sEVMsg = "   DSR"
  Case MSCOMM_EV_CD
    sEVMsg = "   CD"
  Case MSCOMM_EV_RING
    sEVMsg = "  "
  Case MSCOMM_EV_EOF
    sEVMsg = "  "
  '   
  Case MSCOMM_ER_BREAK
    sERMsg = " "
  Case MSCOMM_ER_CTSTO
    sERMsg = "  CTS"
  Case MSCOMM_ER_DSRTO
    sERMsg = "  DSR"
  Case MSCOMM_ER_FRAME
    sERMsg = " "
  Case MSCOMM_ER_OVERRUN
    sERMsg = " "
  Case MSCOMM_ER_CDTO
    sERMsg = "   "
  Case MSCOMM_ER_RXOVER
    sERMsg = "  "
  Case MSCOMM_ER_RXPARITY
    sERMsg = " "
  Case MSCOMM_ER_TXFULL
    sERMsg = "  "
  Case Else
    sERMsg = "   "
  End Select
  '
  If Len(sEVMsg) Then
    '   (  )
    lblM.Caption = sEVMsg
    sEVMsg = ""
  ElseIf Len(sERMsg) Then
    '  
    Beep
    iR = MsgBox(sERMsg, 1, "   ,   .")
    sERMsg = ""
    '
    If iR = 2 Then
      '      (2)
      '    
      comC.PortOpen = False
    End If
  End If
End Sub

Sub SetCom (comC As MSComm, sComSet As String)
  On Error Resume Next
  '
  Dim sNewBPDS As String
  Dim sNewPort As String
  Dim sOldPort As String
  Dim iReOpen As Integer
  Dim sNewShake As String
  '
  Dim iC1 As Integer
  Dim iC2 As Integer
  Dim iC3 As Integer
  Dim iC4 As Integer
  Dim iC5 As Integer
  '
  iC1 = InStr(sComSet, ",")
  iC2 = InStr(iC1 + 1, sComSet, ",")
  iC3 = InStr(iC2 + 1, sComSet, ",")
  iC4 = InStr(iC3 + 1, sComSet, ",")
  iC5 = InStr(iC4 + 1, sComSet, ",")
  sNewBPDS = Left$(sComSet, iC4 - 1)
  sNewPort = Mid$(sComSet, iC5 - 1, 1)
  sNewShake = Mid$(sComSet, iC5 + 1, 1)
  '
  sOldPort = comC.CommPort
  If sNewPort <> sOldPort Then
    If comC.PortOpen Then
      comC.PortOpen = False
      iReOpen = True
    End If
    comC.CommPort = ValDbl(sNewPort)
    If Err = 0 Then
      If iReOpen Then
        comC.PortOpen = True
      End If
    End If
    If Err <> 0 Then
      MsgBox Error$, 48
      comC.CommPort = ValDbl(sOldPort)
      End
    End If
  End If
  '
  comC.Settings = sNewBPDS
  If Err <> 0 Then
    MsgBox Error$, 48
    End
  End If
  '
  comC.Handshaking = sNewShake
  If Err <> 0 Then
    MsgBox Error$, 48
    End
  End If
End Sub
